%define cib_major 4
%define crmcluster_major 4
%define crmcommon_major 3
%define crmservice_major 3
%define lrmd_major 1
%define pengine_major 10
%define pe_rules_major 2
%define pe_status_major 10
%define stonithd_major 2
%define transitioner_major 2

%define cib_libname %mklibname cib %cib_major
%define crmcluster_libname %mklibname crmcluster %crmcluster_major
%define crmcommon_libname %mklibname crmcommon %crmcommon_major
%define crmservice_libname %mklibname crmservice %crmservice_major
%define lrmd_libname %mklibname lrmd %lrmd_major
%define pengine_libname %mklibname pengine %pengine_major
%define pe_rules_libname %mklibname pe_rules %pe_rules_major
%define pe_status_libname %mklibname pe_status %pe_status_major
%define stonithd_libname %mklibname stonithd %stonithd_major
%define transitioner_libname %mklibname transitioner %transitioner_major

%define develname %mklibname pacemaker -d

%global gname haclient
%global uname hacluster
%global pcmk_docdir %{_docdir}/%{name}

%global __python %{__python3}
%global _legacy_common_support 1

# Supported cluster stacks, must support at least one
%bcond_with cman
%bcond_without corosync
%bcond_with heartbeat

# ESMTP is not available in RHEL, only in EPEL. Allow people to build
# the RPM without ESMTP in case they choose not to use EPEL packages
%bcond_without esmtp

# SNMP trap support only works with Net-SNMP 5.4 and above
%bcond_without snmp

# Support additional trace logging
%bcond_with tracedata

# We generate some docs using Publican, but its not available everywhere
%bcond_with publican

%global specversion 2
%global git_hash 394e906

%global pcmk_release %{?alphatag:0.}%{specversion}%{?alphatag:.%{alphatag}}%{?dist}

Name:		pacemaker
Summary:	Scalable High-Availability cluster resource manager
Version:	1.1.19
Release:	%mkrel 9
License:	GPLv2+ and LGPLv2+
Url:		http://www.clusterlabs.org
Group:		System/Base
Source0:	https://github.com/ClusterLabs/pacemaker/archive/Pacemaker-%{version}.tar.gz
Patch0:		pacemaker-1.1.19-CVE-2019-3885.patch
Patch1:		pacemaker-1.1.19-CVE-2018-16877-16878-part1.patch
Patch2:		pacemaker-1.1.19-CVE-2018-16877-16878-part2.patch
Patch3:		pacemaker-1.1.19-CVE-2018-16877-16878-part3.patch
Patch4:		pacemaker-1.1.19-CVE-2018-16877-16878-part4.patch
Patch5:		pacemaker-1.1.19-CVE-2018-16877-16878-part5.patch
Patch6:		pacemaker-1.1.19-CVE-2018-16877-16878-part6.patch
Patch7:		pacemaker-1.1.19-python3.patch
Patch8:		pacemaker-1.1.19-CVE-2020-25654.patch
Requires(pre):	cluster-glue
Requires:	resource-agents
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

# Required for core functionality
BuildRequires:	automake
BuildRequires:	autoconf
BuildRequires:	libtool
BuildRequires:	gcc-c++
BuildRequires:	libltdl-devel
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(python3)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	cluster-glue-devel
BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:	pkgconfig(libxslt)
BuildRequires:	pkgconfig(uuid)
BuildRequires:	pkgconfig(bzip2)
BuildRequires:	pkgconfig(gnutls)
BuildRequires:	pkgconfig(systemd)
BuildRequires:	pkgconfig(dbus-1)

# Enables optional functionality
BuildRequires:	help2man
BuildRequires:	pkgconfig(ncurses)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	docbook-style-xsl
BuildRequires:	resource-agents
BuildRequires:	xsltproc

%if %{with esmtp}
BuildRequires:	libesmtp-devel
%endif

%if %{with snmp}
BuildRequires:	net-snmp-devel >= 5.4
Requires:	net-snmp >= 5.4
%endif

%if %{with corosync}
BuildRequires:	pkgconfig(corosync)
%endif

%if %{with cman}
BuildRequires:	cluster-devel
%endif

%if %{with heartbeat}
BuildRequires:	heartbeat-devel
BuildRequires:	heartbeat-libs
%endif

%if %{with publican}
%ifarch %{ix86} x86_64
BuildRequires:	publican
%endif
%endif

%description
Pacemaker is an advanced, scalable High-Availability cluster resource
manager for Linux-HA (Heartbeat) and/or OpenAIS.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.

%package -n %cib_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %crmcluster_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %crmcommon_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %crmservice_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %lrmd_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %pengine_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %pe_rules_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %pe_status_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %stonithd_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %transitioner_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients

%description -n %cib_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %crmcluster_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %crmcommon_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %crmservice_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %lrmd_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %pengine_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %pe_rules_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %pe_status_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %stonithd_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %transitioner_libname
Library used by the Pacemaker cluster resource manager and its clients

%package -n %{develname}
License:	GPLv2+ and LGPLv2+
Summary:	Pacemaker development package
Group:		System/Libraries
Requires:	%name = %{version}-%{release}
Requires:	%cib_libname = %{version}-%{release}
Requires:	%crmcluster_libname = %{version}-%{release}
Requires:	%crmcommon_libname = %{version}-%{release}
Requires:	%crmservice_libname = %{version}-%{release}
Requires:	%lrmd_libname = %{version}-%{release}
Requires:	%pengine_libname = %{version}-%{release}
Requires:	%pe_rules_libname = %{version}-%{release}
Requires:	%pe_status_libname = %{version}-%{release}
Requires:	%stonithd_libname = %{version}-%{release}
Requires:	%transitioner_libname = %{version}-%{release}
Requires:	cluster-glue-devel
Requires:	libltdl-devel
Provides:	%{name}-devel = %{version}-%{release}
%if %{with corosync}
Requires:	corosync-devel
%endif
%if %{with heartbeat}
Requires:	heartbeat-devel
%endif

%description -n %{develname}
Headers and shared libraries for developing tools for Pacemaker.

Pacemaker is an advanced, scalable High-Availability cluster resource
manager for Linux-HA (Heartbeat) and/or OpenAIS.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.

%package	cts
License:	GPLv2+ and LGPLv2+
Summary:	Test framework for cluster-related technologies like Pacemaker
Group:		System/Base
Requires:	python3

%description	cts
Test framework for cluster-related technologies like Pacemaker

%package	doc
License:	GPLv2+ and LGPLv2+
Summary:	Documentation for Pacemaker
Group:		Documentation
BuildArch:	noarch

%description	doc
Documentation for Pacemaker.

Pacemaker is an advanced, scalable High-Availability cluster resource
manager for OpenAIS/Corosync.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.

%prep
%setup -q -n %name-Pacemaker-%{version}
%autopatch -p1

%build
export PYTHON=%{__python3}

./autogen.sh

%configure						\
	%{!?with_heartbeat: --without-heartbeat}	\
	%{!?with_corosync:  --without-corosync}		\
	%{!?with_esmtp:     --without-esmtp}		\
	%{!?with_snmp:      --without-snmp}		\
	%{?with_cman:       --with-cman}		\
	%{?with_profiling:  --with-profiling}		\
	%{?with_gcov:       --with-gcov}		\
	%{?with_tracedata   --with-tracedata}		\
	--with-version=%{version}-%{release}		\
	--docdir=%{pcmk_docdir}				\
	--localstatedir=%{_var}				\
	--enable-fatal-warnings=no			\
	--disable-ansi					\
	--enable-systemd


%make_build

%install
%make_install

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 mcp/pacemaker.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/pacemaker

# Scripts that should be executable
chmod a+x %{buildroot}%{_datadir}/pacemaker/tests/cts/CTSlab.py

# These are not actually scripts
find %{buildroot} -name '*.xml' -type f -print0 | xargs -0 chmod a-x
find %{buildroot} -name '*.xsl' -type f -print0 | xargs -0 chmod a-x
find %{buildroot} -name '*.rng' -type f -print0 | xargs -0 chmod a-x
find %{buildroot} -name '*.dtd' -type f -print0 | xargs -0 chmod a-x
 
# Dont package static libs or compiled python
find %{buildroot} -name '*.a' -type f -print0 | xargs -0 rm -f
find %{buildroot} -name '*.la' -type f -print0 | xargs -0 rm -f

# Don't package these either
rm -f %{buildroot}%{_libdir}/heartbeat/hb2openais-helper.*
rm -f %{buildroot}%{_libdir}/heartbeat/crm_primitive.*
rm -f %{buildroot}%{_libdir}/service_crm.so
rm -f %{buildroot}%{_prefix}/lib/ocf/resource.d/pacemaker/pingd

# Don't package old initscripts
rm -f %{buildroot}/etc/init.d/pacemaker
rm -f %{buildroot}/etc/init.d/pacemaker_remote

%files
###########################################################
%config(noreplace) %{_sysconfdir}/sysconfig/pacemaker
%{_sysconfdir}/logrotate.d/pacemaker
%{_unitdir}/pacemaker.service
%{_unitdir}/crm_mon.service
%{_unitdir}/pacemaker_remote.service
%{_sbindir}/pacemakerd
%{_datadir}/pacemaker
%{_datadir}/snmp/mibs/PCMK-MIB.txt
%{_sbindir}/cibadmin
%{_sbindir}/crm_attribute
%{_sbindir}/crm_diff
%{_sbindir}/crm_failcount
%{_sbindir}/crm_master
%{_sbindir}/crm_mon
%{_sbindir}/crm_simulate
%{_sbindir}/crm_resource
%{_sbindir}/crm_report
%{_sbindir}/crm_standby
%{_sbindir}/crm_ticket
%{_sbindir}/crm_verify
%{_sbindir}/crmadmin
%{_sbindir}/iso8601
%{_sbindir}/attrd_updater
%{_sbindir}/crm_shadow
%{_sbindir}/crm_error
%{_sbindir}/crm_node
%{_sbindir}/fence_legacy
%{_sbindir}/fence_pcmk
%{_sbindir}/stonith_admin
%{_sbindir}/pacemaker_remoted
%{_libexecdir}/pacemaker
%{_mandir}/man7/crmd.7*
%{_mandir}/man7/ocf_pacemaker_*
%{_mandir}/man7/pengine.7*
%{_mandir}/man7/stonithd.7*
%{_mandir}/man8/attrd_updater.8*
%{_mandir}/man8/stonith_admin.8*
%{_mandir}/man8/cibadmin.8*
%{_mandir}/man8/crmadmin.8*
%{_mandir}/man8/crm_*
%{_mandir}/man8/fence_legacy.8*
%{_mandir}/man8/iso8601.8*
%{_mandir}/man8/pacemakerd.8*
%{_mandir}/man8/pacemaker_remoted.8*
%{_mandir}/man8/fence_pcmk.8*

# Packaged elsewhere
%exclude %{_datadir}/pacemaker/tests

%dir %{_prefix}/lib/ocf
%dir %{_prefix}/lib/ocf/resource.d
%{_prefix}/lib/ocf/resource.d/pacemaker
%{_prefix}/lib/ocf/resource.d/.isolation/docker-wrapper

%files -n %cib_libname
%{_libdir}/libcib.so.%{cib_major}{,.*}
%files -n %crmcluster_libname
%{_libdir}/libcrmcluster.so.%{crmcluster_major}{,.*}
%files -n %crmcommon_libname
%{_libdir}/libcrmcommon.so.%{crmcommon_major}{,.*}
%files -n %crmservice_libname
%{_libdir}/libcrmservice.so.%{crmservice_major}{,.*}
%files -n %lrmd_libname
%{_libdir}/liblrmd.so.%{lrmd_major}{,.*}
%files -n %pengine_libname
%{_libdir}/libpengine.so.%{pengine_major}{,.*}
%files -n %pe_rules_libname
%{_libdir}/libpe_rules.so.%{pe_rules_major}{,.*}
%files -n %pe_status_libname
%{_libdir}/libpe_status.so.%{pe_status_major}{,.*}
%files -n %stonithd_libname
%{_libdir}/libstonithd.so.%{stonithd_major}{,.*}
%files -n %transitioner_libname
%{_libdir}/libtransitioner.so.%{transitioner_major}{,.*}

%files doc
%doc %{pcmk_docdir}

%files cts
%{python3_sitearch}/cts
%{_datadir}/pacemaker/tests/cts

%files -n %{develname}
%exclude %{_datadir}/pacemaker/tests/cts
%{_datadir}/pacemaker/tests
%{_includedir}/pacemaker/
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc


%changelog
* Wed Nov 04 2020 ns80 <ns80> 1.1.19-9.mga8
+ Revision: 1642526
- backport patch for CVE-2020-25654 (mga#27472)

* Tue Nov 03 2020 akien <akien> 1.1.19-8.mga8
+ Revision: 1642022
- Rebuild for new libnetsnmp

* Thu Aug 20 2020 joequant <joequant> 1.1.19-7.mga8
+ Revision: 1616891
- fix build for gcc10

* Thu Feb 20 2020 umeabot <umeabot> 1.1.19-6.mga8
+ Revision: 1545645
- Mageia 8 Mass Rebuild

* Wed Jan 29 2020 daviddavid <daviddavid> 1.1.19-5.mga8
+ Revision: 1485048
- switch to python3

* Wed Jan 29 2020 daviddavid <daviddavid> 1.1.19-4.mga8
+ Revision: 1485018
- rebuild for new libqb 1.0.5
- rebuild for new corosync 3.0.3

* Tue Dec 17 2019 ns80 <ns80> 1.1.19-3.mga8
+ Revision: 1468618
- add upstream patches for CVE-2018-1687[78] and CVE-2019-3885 (mga#24691)

* Sat Dec 29 2018 luigiwalser <luigiwalser> 1.1.19-2.mga7
+ Revision: 1346031
- rebuild for net-snmp

* Sat Sep 15 2018 daviddavid <daviddavid> 1.1.19-1.mga7
+ Revision: 1259061
- new version: 1.1.19
- fix some libmajor number

* Fri Mar 02 2018 kekepower <kekepower> 1.1.18-1.mga7
+ Revision: 1206080
- Update to version 1.1.18

* Tue Mar 07 2017 ennael <ennael> 1.1.16-1.mga6
+ Revision: 1089610
- new version 1.1.16

* Mon Jan 11 2016 luigiwalser <luigiwalser> 1.1.8-10.mga6
+ Revision: 921830
- rebuild for gnutls

* Wed Oct 15 2014 umeabot <umeabot> 1.1.8-9.mga5
+ Revision: 740722
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.1.8-8.mga5
+ Revision: 683303
- Mageia 5 Mass Rebuild
+ pterjan <pterjan>
- Rebuild for new Python

* Sun Jan 12 2014 philippem <philippem> 1.1.8-6.mga4
+ Revision: 566353
- applied upstream patch to fix CVE-2013-0281 mga#11724

* Fri Oct 18 2013 umeabot <umeabot> 1.1.8-5.mga4
+ Revision: 521353
- Mageia 4 Mass Rebuild

* Mon Jan 21 2013 fwang <fwang> 1.1.8-4.mga3
+ Revision: 390549
- cleanup spec

* Mon Jan 21 2013 fwang <fwang> 1.1.8-3.mga3
+ Revision: 390468
- revise patch so that files are not need to be copied

* Mon Jan 21 2013 fwang <fwang> 1.1.8-2.mga3
+ Revision: 390417
- location moved
- more linkage fix
- fix patch
- more patch
- move libpe_rules out of pengine so that link order is correct
- more linkage fix
- apply link patch
- correct link patch

* Sun Jan 20 2013 colin <colin> 1.1.8-1.mga3
+ Revision: 390172
- Fix build after previous (non-built) upgrades
- Don't bother ghosting the rundir (no other pkgs do this)
+ umeabot <umeabot>
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild
+ ennael <ennael>
- fix pengine Makefile.am
- new version
- AM_CONFIG_HEADER fix

* Fri Nov 30 2012 pterjan <pterjan> 1.1.7-3.mga3
+ Revision: 323262
- Hide an expected failure from iurt, else it will ignore that the rpm actually built
- Add upstream patch fixing missing headers

* Sat Apr 28 2012 tmb <tmb> 1.1.7-2.mga2
+ Revision: 233833
- Require rpm-helper >= 0.24.8-1 for systemd support

* Fri Apr 20 2012 boklm <boklm> 1.1.7-1.mga2
+ Revision: 232064
- version 1.1.7
- remove old patchs
- rename ais bcond to corosync
- enable systemd
- disable cman

* Mon Apr 02 2012 ennael <ennael> 1.1.6-3.mga2
+ Revision: 227906
- fix wrong buildrequires

* Mon Apr 02 2012 ennael <ennael> 1.1.6-2.mga2
+ Revision: 227901
- remove wrong require

* Mon Apr 02 2012 boklm <boklm> 1.1.6-1.mga2
+ Revision: 227883
- add xsltproc as BR, needed to generate man pages
- split libraries in different packages
- update to version 2.1.6
- drop patchs merged upstream
- update makefile patch
- remove patch splitting pengine directory, but run multiple make to avoid
  link failure, as temporary solution until upstream split the directory
  (thanks to rtp for help)
- re-enable cman
- disable cman and heartbeat
- imported package pacemaker
+ ennael <ennael>
- fix man pages
- clean spec (man pages, provides, group)
- fix groups
- add missing files
- add patch for ocf-shellfuncs
- patch for ocf-shellfuncs path
- fix release tag and group
- fix more buildrequires
- fix buildrequires
+ rtp <rtp>
- Fix multiples build errors.


* Wed Apr 27 2011 Andrew Beekhof <andrew@beekhof.net> 1.1.5-2
- Mark /var/run directories with ghost directive
  Resolves: rhbz#656654

* Wed Apr 27 2011 Andrew Beekhof <andrew@beekhof.net> 1.1.5-1
- New upstream release plus patches for CMAN integration
 
* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.4-5.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Jan 11 2011 Andrew Beekhof <andrew@beekhof.net> 1.1.4-5
- Re-enable corosync and heartbeat support with correct bcond variable
  usage

* Wed Dec  8 2010 Fabio M. Di Nitto <fdinitto@redhat.com> 1.1.4-4
- Temporary drop publican doc build

* Wed Dec  8 2010 Fabio M. Di Nitto <fdinitto@redhat.com> 1.1.4-3
- Fix publican build on x86

* Wed Dec  8 2010 Fabio M. Di Nitto <fdinitto@redhat.com> 1.1.4-2
- Drop double source entry and 22Mb from the srpm

* Mon Nov 15 2010 Andrew Beekhof <andrew@beekhof.net> 1.1.4-1
- Upstream release of 1.1.4
- See included ChangeLog file or http://hg.clusterlabs.org/pacemaker/1.1/file/tip/ChangeLog for details

* Wed Sep 29 2010 jkeating - 1.1.3-1.1
- Rebuilt for gcc bug 634757

* Thu Sep 21 2010 Andrew Beekhof <andrew@beekhof.net> - 1.1.3-1
- Upstream release of 1.1.3
  + High: crmd: Use the correct define/size for lrm resource IDs
  + High: crmd: Bug lf#2458 - Ensure stop actions always have the relevant resource attributes
  + High: crmd: Ensure we activate the DC timer if we detect an alternate DC
  + High: mcp: Correctly initialize the string containing the list of active daemons
  + High: mcp: Fix the expansion of the pid file in the init script
  + High: mcp: Tell chkconfig we need to shut down early on
  + High: PE: Bug lf#2476 - Repair on-fail=block for groups and primitive resources
  + High: PE: Do not demote resources because something that requires it can't run
  + High: PE: Rewrite the ordering constraint logic to be simplicity, clarity and maintainability
  + High: PE: Wait until stonith is available, don't fall back to shutdown for nodes requesting termination
  + High: PE: Prevent segfault by ensuring the arguments to do_calculations() are initialized
  + High: stonith: Bug lf#2461 - Prevent segfault by not looking up operations if the hashtable hasn't been initialized yet
  + High: Stonith: Bug lf#2473 - Ensure stonith operations complete within the timeout and are terminated if they run too long
  + High: stonith: Bug lf#2473 - Gracefully handle remote operations that arrive late (after we've done notifications)
  + High: stonith: Bug lf#2473 - Add the timeout at the top level where the daemon is looking for it
  + High: stonith: Bug lf#2473 - Ensure timeouts are included for fencing operations
  + High: Stonith: Use the timeout specified by the user
  + High: Tools: Bug lf#2456 - Fix assertion failure in crm_resource
* Mon Jul 26 2010 Andrew Beekhof <andrew@beekhof.net> - 1.1.3-0.1-b3cb4f4a30ae.hg
- Pre-release version of 1.1.3
  + High: ais: Bug lf2401 - Improved processing when the peer crmd processes join/leave
  + High: ais: fix list of active processes sent to clients (bnc#603685)
  + High: ais: Move the code for finding uid before the fork so that the child does no logging
  + High: ais: Resolve coverity CONSTANT_EXPRESSION_RESULT defects
  + High: cib: Also free query result for xpath operations that return more than one hit
  + High: cib: Attempt to resolve memory corruption when forking a child to write the cib to disk
  + High: cib: Correctly free memory when writing out the cib to disk
  + High: cib: Fix the application of unversioned diffs
  + High: cib: Remove old developmental error logging
  + High: cib: Restructure the 'valid peer' check for deciding which instructions to ignore
  + High: Core: Bug lf#2401 - Backed out changeset 6e6980376f01
  + High: Core: Correctly unpack HA_Messages containing multiple entries with the same name
  + High: Core: crm_count_member() should only track nodes that have the full stack up
  + High: Core: New developmental logging system inspired by the kernel and a PoC from Lars Ellenberg
  + High: crmd: All nodes should see status updates, not just he DC
  + High: crmd: Allow non-DC nodes to clear failcounts too
  + High: crmd: Base DC election on process relative uptime
  + High: crmd: Bug lf#2439 - cancel_op() can also return HA_RSCBUSY
  + High: crmd: Bug lf#2439 - Handle asynchronous notification of resource deletion events
  + High: crmd: Fix assertion failure when performing async resource failures
  + High: crmd: Fix handling of async resource deletion results
  + High: crmd: Include the action for crm graph operations
  + High: crmd: Make sure the membership cache is accurate after a sucessful fencing operation
  + High: crmd: Make sure we always poke the FSA after a transition to clear any TE_HALT actions
  + High: crmd: Offer crm-level membership once the peer starts the crmd process
  + High: crmd: Only need to request quorum update for plugin based clusters
  + High: crmd: Prevent everyone from loosing DC elections by correctly initializing all relevant variables
  + High: crmd: Prevent segmentation fault
  + High: crmd: several fixes for async resource delete
  + High: mcp: Add missing headers when built without heartbeat support
  + High: mcp: New master control process for (re)spawning pacemaker daemons
  + High: PE: Avoid creating invalid ordering constraints for probes that are not needed
  + High: PE: Bug lf#1959 - Fail unmanaged resources should not prevent other services from shutting down
  + High: PE: Bug lf#2422 - Ordering dependencies on partially active groups not observed properly
  + High: PE: Bug lf#2424 - Use notify oepration definition if it exists in the configuration
  + High: PE: Bug lf#2433 - No services should be stopped until probes finish
  + High: PE: Bug lf#2453 - Enforce clone ordering in the absense of colocation constraints
  + High: PE: Correctly detect when there is a real failcount that expired and needs to be cleared
  + High: PE: Correctly handle pseudo action creation
  + High: PE: Correctly order clone startup after group/clone start
  + High: PE: Fix colocation for interleaved clones
  + High: PE: Fix colocation with partially active groups
  + High: PE: Fix potential use-after-free defect from coverity
  + High: PE: Fix previous merge
  + High: PE: Fix use-after-free in order_actions() reported by valgrind
  + High: PE: Prevent endless loop when looking for operation definitions in the configuration
  + High: Resolve coverity RESOURCE_LEAK defects
  + High: Shell: Complete the transition to using crm_attribute instead of crm_failcount and crm_standby
  + High: stonith: Advertise stonith-ng options in the metadata
  + High: stonith: Correctly parse pcmk_host_list parameters that appear on a single line
  + High: stonith: Map poweron/poweroff back to on/off expected by the stonith tool from cluster-glue
  + High: stonith: pass the configuration to the stonith program via environment variables (bnc#620781)
  + High: Support starting plugin-based Pacemaker clusters with the MCP as well
  + High: tools: crm_report - corosync.conf wont necessarily contain the text 'pacemaker' anymore
  + High: tools: crm_simulate - Resolve coverity USE_AFTER_FREE defect
  + High: Tools: Drop the 'pingd' daemon and resource agent in favor of ocf:pacemaker:ping
  + High: Tools: Fix recently introduced use-of-NULL
  + High: Tools: Fix use-after-free defect from coverity

* Wed Jul 21 2010 David Malcolm <dmalcolm@redhat.com> - 1.1.2-5.1
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Fri Jul  9 2010 Dan Horák <dan[at]danny.cz> - 1.1.2-5
- re-enable AIS cluster on s390(x)

* Fri Jul  9 2010 Dan Horák <dan[at]danny.cz> - 1.1.2-4
- AIS cluster not available on s390(x)

* Mon Jun 21 2010 Andrew Beekhof <andrew@beekhof.net> - 1.1.2-3
- publican is only available as a dependancy on i386/x86_64 machines

* Fri Jun 11 2010 Andrew Beekhof <andrew@beekhof.net> - 1.1.2-2
- Resolves rhbz#602239 - Added patch to documentation so that it passes validation
- High: Core: Bug lf#2401 - Backed out changeset 6e6980376f01

* Tue Jun 01 2010 Marcela Maslanova <mmaslano@redhat.com> - 1.1.2-1.1
- Mass rebuild with perl-5.12.0

* Wed May 12 2010 Andrew Beekhof <andrew@beekhof.net> - 1.1.2-1
- Update the tarball from the upstream 1.1.2 release 
  + High: ais: Bug lf#2340 - Force rogue child processes to terminate after waiting 2.5 minutes
  + High: ais: Bug lf#2359 - Default expected votes to 2 inside Corosync/OpenAIS plugin
  + High: ais: Bug lf#2359 - expected-quorum-votes not correctly updated after membership change
  + High: ais: Bug rhbz#525552 - Move non-threadsafe calls to setenv() to after the fork()
  + High: ais: Do not count votes from offline nodes and calculate current votes before sending quorum data
  + High: ais: Ensure the list of active processes sent to clients is always up-to-date
  + High: ais: Fix previous commit, actually return a result in get_process_list()
  + High: ais: Fix two more uses of getpwnam() in non-thread-safe locations
  + High: ais: Look for the correct conf variable for turning on file logging
  + High: ais: Need to find a better and thread-safe way to set core_uses_pid. Disable for now.
  + High: ais: Use the threadsafe version of getpwnam
  + High: Core: Bug lf#2414 - Prevent use-after-free reported by valgrind when doing xpath based deletions
  + High: Core: Bump the feature set due to the new failcount expiry feature
  + High: Core: Fix memory leak in replace_xml_child() reported by valgrind
  + High: Core: fix memory leaks exposed by valgrind
  + High: crmd: Bug 2401 - Improved detection of partially active peers
  + High: crmd: Bug bnc#578644 - Improve handling of cancelled operations caused by resource cleanup
  + High: crmd: Bug lf#2379 - Ensure the cluster terminates when the PE is not available
  + High: crmd: Bug lf#2414 - Prevent use-after-free of the PE connection after it dies
  + High: crmd: Bug lf#2414 - Prevent use-after-free of the stonith-ng connection
  + High: crmd: Do not allow the target_rc to be misused by resource agents
  + High: crmd: Do not ignore action timeouts based on FSA state
  + High: crmd: Ensure we dont get stuck in S_PENDING if we loose an election to someone that never talks to us again
  + High: crmd: Fix memory leaks exposed by valgrind
  + High: crmd: Remove race condition that could lead to multiple instances of a clone being active on a machine
  + High: crmd: Send erase_status_tag() calls to the local CIB when the DC is fenced, since there is no DC to accept them
  + High: crmd: Use global fencing notifications to prevent secondary fencing operations of the DC
  + High: fencing: Account for stonith_get_info() always returning a pointer to the same static buffer
  + High: PE: Allow startup probes to be disabled - their calculation is a major bottleneck for very large clusters
  + High: PE: Bug lf#2317 - Avoid needless restart of primitive depending on a clone
  + High: PE: Bug lf#2358 - Fix master-master anti-colocation
  + High: PE: Bug lf#2361 - Ensure clones observe mandatory ordering constraints if the LHS is unrunnable
  + High: PE: Bug lf#2383 - Combine failcounts for all instances of an anonymous clone on a host
  + High: PE: Bug lf#2384 - Fix intra-set colocation and ordering
  + High: PE: Bug lf#2403 - Enforce mandatory promotion (colocation) constraints
  + High: PE: Bug lf#2412 - Correctly locate clone instances by their prefix
  + High: PE: Correctly implement optional colocation between primitives and clone resources
  + High: PE: Do not be so quick to pull the trigger on nodes that are coming up
  + High: PE: Fix memory leaks exposed by valgrind
  + High: PE: Fix memory leaks reported by valgrind
  + High: PE: Repair handling of unordered groups in RHS ordering constraints
  + High: PE: Rewrite native_merge_weights() to avoid Fix use-after-free
  + High: PE: Suppress duplicate ordering constraints to achieve orders of magnitude speed increases for large clusters
  + High: Shell: add support for xml in cli
  + High: Shell: always reload status if working with the cluster (bnc#590035)
  + High: Shell: check timeouts also against the default-action-timeout property
  + High: Shell: Default to using the status section from the live CIB (bnc#592762)
  + High: Shell: edit multiple meta_attributes sets in resource management (lf#2315)
  + High: Shell: enable comments (lf#2221)
  + High: Shell: implement new cibstatus interface and commands (bnc#580492)
  + High: Shell: improve configure commit (lf#2336)
  + High: Shell: new cibstatus import command (bnc#585471)
  + High: Shell: new configure filter command
  + High: Shell: restore error reporting in options
  + High: Shell: split shell into modules
  + High: Shell: support for the utilization element (old patch for the new structure)
  + High: Shell: update previous node lookup procedure to include the id where necessary
  + High: Tools: crm_mon - fix memory leaks exposed by valgrind

* Thu Feb 11 2010 Andrew Beekhof <andrew@beekhof.net> - 1.1.1-0.1-60b7753f7310.hg
- Update the tarball from upstream to version 60b7753f7310
  + First public release of the 1.1 series

* Wed Dec 9 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.5-5
- Include patch of changeset 66b7bfd467f3:
  Some clients such as gfs_controld want a cluster name, allow one to be specified in corosync.conf

* Thu Oct 29 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.5-4
- Include the fixes from CoroSync integration testing
- Move the resource templates - they are not documentation
- Ensure documentation is placed in a standard location
- Exclude documentation that is included elsewhere in the package

- Update the tarball from upstream to version ee19d8e83c2a
  + High: cib: Correctly clean up when both plaintext and tls remote ports are requested
  + High: PE: Bug bnc#515172 - Provide better defaults for lt(e) and gt(e) comparisions
  + High: PE: Bug lf#2197 - Allow master instances placemaker to be influenced by colocation constraints
  + High: PE: Make sure promote/demote pseudo actions are created correctly
  + High: PE: Prevent target-role from promoting more than master-max instances
  + High: ais: Bug lf#2199 - Prevent expected-quorum-votes from being populated with garbage
  + High: ais: Prevent deadlock - dont try to release IPC message if the connection failed
  + High: cib: For validation errors, send back the full CIB so the client can display the errors
  + High: cib: Prevent use-after-free for remote plaintext connections
  + High: crmd: Bug lf#2201 - Prevent use-of-NULL when running heartbeat
  + High: Core: Bug lf#2169 - Allow dtd/schema validation to be disabled
  + High: PE: Bug lf#2106 - Not all anonymous clone children are restarted after configuration change
  + High: PE: Bug lf#2170 - stop-all-resources option had no effect
  + High: PE: Bug lf#2171 - Prevent groups from starting if they depend on a complex resource which cannot
  + High: PE: Disable resource management if stonith-enabled=true and no stonith resources are defined
  + High: PE: Do not include master score if it would prevent allocation
  + High: ais: Avoid excessive load by checking for dead children every 1s (instead of 100ms)
  + High: ais: Bug rh#525589 - Prevent shutdown deadlocks when running on CoroSync
  + High: ais: Gracefully handle changes to the AIS nodeid
  + High: crmd: Bug bnc#527530 - Wait for the transition to complete before leaving S_TRANSITION_ENGINE
  + High: crmd: Prevent use-after-free with LOG_DEBUG_3
  + Medium: xml: Mask the "symmetrical" attribute on rsc_colocation constraints (bnc#540672)
  + Medium (bnc#520707): Tools: crm: new templates ocfs2 and clvm
  + Medium: Build: Invert the disable ais/heartbeat logic so that --without (ais|heartbeat) is available to rpmbuild
  + Medium: PE: Bug lf#2178 - Indicate unmanaged clones
  + Medium: PE: Bug lf#2180 - Include node information for all failed ops
  + Medium: PE: Bug lf#2189 - Incorrect error message when unpacking simple ordering constraint
  + Medium: PE: Correctly log resources that would like to start but cannot
  + Medium: PE: Stop ptest from logging to syslog
  + Medium: ais: Include version details in plugin name
  + Medium: crmd: Requery the resource metadata after every start operation

* Fri Oct  9 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 1.0.5-3
- rebuilt with new net-snmp

* Fri Aug 21 2009 Tomas Mraz <tmraz@redhat.com> - 1.0.5-2.1
- rebuilt with new openssl

* Wed Aug 19 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.5-2
- Add versioned perl dependancy as specified by
    https://fedoraproject.org/wiki/Packaging/Perl#Packages_that_link_to_libperl
- No longer remove RPATH data, it prevents us finding libperl.so and no other
  libraries were being hardcoded
- Compile in support for heartbeat
- Conditionally add heartbeat-devel and corosynclib-devel to the -devel requirements 
  depending on which stacks are supported

* Mon Aug 17 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.5-1
- Add dependancy on resource-agents
- Use the version of the configure macro that supplies --prefix, --libdir, etc
- Update the tarball from upstream to version 462f1569a437 (Pacemaker 1.0.5 final)
  + High: Tools: crm_resource - Advertise --move instead of --migrate
  + Medium: Extra: New node connectivity RA that uses system ping and attrd_updater
  + Medium: crmd: Note that dc-deadtime can be used to mask the brokeness of some switches

* Tue Aug 11 2009 Ville Skyttä <ville.skytta@iki.fi> - 1.0.5-0.7.c9120a53a6ae.hg
- Use bzipped upstream tarball.

* Wed Jul  29 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.5-0.6.c9120a53a6ae.hg
- Add back missing build auto* dependancies
- Minor cleanups to the install directive

* Tue Jul  28 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.5-0.5.c9120a53a6ae.hg
- Add a leading zero to the revision when alphatag is used

* Tue Jul  28 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.5-0.4.c9120a53a6ae.hg
- Incorporate the feedback from the cluster-glue review
- Realistically, the version is a 1.0.5 pre-release
- Use the global directive instead of define for variables
- Use the haclient/hacluster group/user instead of daemon
- Use the _configure macro
- Fix install dependancies

* Fri Jul  24 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.4-3
- Include an AUTHORS and license file in each package
- Change the library package name to pacemaker-libs to be more 
  Fedora compliant
- Remove execute permissions from xml related files
- Reference the new cluster-glue devel package name
- Update the tarball from upstream to version c9120a53a6ae
  + High: PE: Only prevent migration if the clone dependancy is stopping/starting on the target node
  + High: PE: Bug 2160 - Dont shuffle clones due to colocation
  + High: PE: New implementation of the resource migration (not stop/start) logic
  + Medium: Tools: crm_resource - Prevent use-of-NULL by requiring a resource name for the -A and -a options
  + Medium: PE: Prevent use-of-NULL in find_first_action()
  + Low: Build: Include licensing files

* Tue Jul 14 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.4-2
- Reference authors from the project AUTHORS file instead of listing in description
- Change Source0 to reference the project's Mercurial repo
- Cleaned up the summaries and descriptions
- Incorporate the results of Fedora package self-review

* Tue Jul 14 2009 Andrew Beekhof <andrew@beekhof.net> - 1.0.4-1
- Initial checkin
